#include "StdAfx.h"
#include ".\camera.h"

CCamera::CCamera(void)
{
}

CCamera::~CCamera(void)
{
}

void CCamera::SetPosition(D3DXVECTOR3 pos)
{
	this->pos = pos;
}

D3DXVECTOR3 CCamera::GetPosition(void)
{
	return pos;
}

D3DXVECTOR3 CCamera::GetRight(void)
{
	return right;
}

D3DXVECTOR3 CCamera::GetUp(void)
{
	return up;
}

D3DXVECTOR3 CCamera::GetLook(void)
{
	return look;
}



void CCamera::strafe(float units)
{
	pos += right * units;
}

void CCamera::fly(float units)
{
	pos += up * units;
}



void CCamera::walk(float units)
{
	pos += look * units;
}

void CCamera::pitch(float angle)
{
	D3DXMATRIX T;
     D3DXMatrixRotationAxis(&T, &right, angle);
     //   up  look   right
     D3DXVec3TransformCoord(&up,&up, &T);
     D3DXVec3TransformCoord(&look,&look, &T);

}



void CCamera::yaw(float angle)
{
	 D3DXMATRIX T;

     

     //     
     //   
     
          D3DXMatrixRotationAxis(&T, &up, angle);

     //   right  look 
     //  up   Y
     D3DXVec3TransformCoord(&right, &right, &T);
     D3DXVec3TransformCoord(&look, &look, &T);

}



void CCamera::roll(float angle)
{
	D3DXMATRIX T;
    D3DXMatrixRotationAxis(&T, &look, angle);

          //   up  right 
          //  look
    D3DXVec3TransformCoord(&right, &right, &T);
    D3DXVec3TransformCoord(&up, &up, &T);

}





D3DXMATRIXA16 CCamera::GetViewMatrix(void)
{
     D3DXVec3Normalize(&look, &look);

	 D3DXVec3Cross(&right, &up, &look);
     D3DXVec3Normalize(&right, &right);

     D3DXVec3Cross(&up, &look, &right);
     D3DXVec3Normalize(&up, &up);

     

     //   :
     float x = -D3DXVec3Dot(&right, &pos);
     float y = -D3DXVec3Dot(&up, &pos);
     float z = -D3DXVec3Dot(&look, &pos);

	 D3DXMATRIX V;
     V(0, 0) = right.x;
     V(0, 1) = up.x;
     V(0, 2) = look.x;
     V(0, 3) = 0.0f;

     V(1, 0) = right.y;
     V(1, 1) = up.y;
     V(1, 2) = look.y;
     V(1, 3) = 0.0f;

     V(2, 0) = right.z;
     V(2, 1) = up.z;
     V(2, 2) = look.z;
     V(2, 3) = 0.0f;

     V(3, 0) = x;
     V(3, 1) = y;
     V(3, 2) = z;
     V(3, 3) = 1.0f;

	return V;
}

void CCamera::SetUp(D3DXVECTOR3 _up)
{
	this->up = _up;
}

void CCamera::SetLook(D3DXVECTOR3 _look)
{
	D3DXVECTOR3 tv = _look - pos;
	D3DXVec3Normalize(&tv, &tv);
	this->look = tv;
}
