// lab6d3d.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "lab6d3d.h"
#include <mmsystem.h>
#include <d3dx9.h>
#include "Camera.h"
//#include <dxut.h>
#pragma warning( disable : 4996 ) // disable deprecated warning 
#include <strsafe.h>
#pragma warning( default : 4996 ) 

#define MAX_LOADSTRING 100
//  
float l0=1.0f,l1=1.0f;
/////////////////////////////////////////////////////
char* OpenNewFile( HWND hwnd, const char *wndTitle, char *InitialDir=NULL,char * filter="All Files (*.*)\0*.*\0"  )
{
    static char file[256];
    static char fileTitle[256];
    //static char filter[] = "All Files (*.*)\0*.*\0";
    OPENFILENAME ofn;

    lstrcpy( file, "");
    lstrcpy( fileTitle, "");

    ofn.lStructSize       = sizeof(OPENFILENAME);
    ofn.hwndOwner         = hwnd;
#ifdef WIN32
    ofn.hInstance         = (HINSTANCE) GetWindowLong(hwnd, GWL_HINSTANCE);
#else
    ofn.hInstance         = (HINSTANCE) GetWindowWord(hwnd, GWW_HINSTANCE);
#endif
    ofn.lpstrFilter       = filter;
    ofn.lpstrCustomFilter = (LPSTR) NULL;
    ofn.nMaxCustFilter    = 0L;
    ofn.nFilterIndex      = 1L;
    ofn.lpstrFile         = file;
    ofn.nMaxFile          = sizeof(file);
    ofn.lpstrFileTitle    = fileTitle;
    ofn.nMaxFileTitle     = sizeof(fileTitle);
    ofn.lpstrInitialDir   = InitialDir;
    ofn.lpstrTitle        = wndTitle;
    ofn.nFileOffset       = 0;
    ofn.nFileExtension    = 0;
    ofn.lpstrDefExt       = "*";
    ofn.lCustData         = 0;

    ofn.Flags =  OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST |OFN_NOCHANGEDIR ;

    if (GetOpenFileName(&ofn))
	{
		const int  MAX=256;
		char * CurDir=new char[MAX];
		char *FirstChars=new char[MAX];
		GetCurrentDirectory(MAX,CurDir);
		unsigned int n;
		for ( n=0; n<strlen(CurDir);n++)
			FirstChars[n]=ofn.lpstrFile[n];
		FirstChars[n]=0;
		//strcat(CurDir,"\\");
	//	strcat(CurDir,ofn.lpstrFileTitle);
	
		if (strcmpi(FirstChars,CurDir)==0)
		{
			delete CurDir; delete FirstChars;
			return (char *)&((ofn.lpstrFile)[n+1]);
		}
		else
		{
			delete CurDir; delete FirstChars;
			return (char*)ofn.lpstrFile;
		}
	}
    else
        return NULL;
}

//      mesh:
class CMesh{
public:
	LPD3DXMESH              g_pMesh          ; // Our mesh object in sysmem
	D3DMATERIAL9*           g_pMeshMaterials ; // Materials for our mesh
	LPDIRECT3DTEXTURE9*     g_pMeshTextures  ; // Textures for our mesh
	DWORD                   g_dwNumMaterials ;   // Number of mesh material
	CMesh():g_pMesh(NULL),g_pMeshMaterials(NULL),g_pMeshTextures(0L){}
	void Draw();
	HRESULT LoadFromFile(char *FileName);
};
CMesh room;
// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

LPDIRECT3D9             g_pD3D       = NULL; // Used to create the D3DDevice
LPDIRECT3DDEVICE9       g_pd3dDevice = NULL; // Our rendering device
LPDIRECT3DVERTEXBUFFER9 g_pVB        = NULL;
LPDIRECT3DINDEXBUFFER9  g_pIB        = NULL;
double angle;
float aspectRatio;
int width, height;
ID3DXMesh* mesh = 0;
float timeDelta = 0;
DWORD stm;
CCamera camera;
LPDIRECT3DTEXTURE9 Tex = NULL;
LPDIRECT3DTEXTURE9 TexSphere = NULL;







//LPDXUTCALLBACKTIMER OnTimer (UINT idEvent,  void* pUserContext)
//{
//

void MyTimerProc()
{
	angle += 0.05f;
	if (angle > D3DX_PI*2)
		angle = 0.0f;

	
}



HRESULT InitD3D( HWND hWnd )
{
    // Create the D3D object, which is needed to create the D3DDevice.
    if( NULL == ( g_pD3D = Direct3DCreate9( D3D_SDK_VERSION ) ) )
        return E_FAIL;

	D3DCAPS9 caps;
	g_pD3D->GetDeviceCaps(
      D3DADAPTER_DEFAULT, //   .
	  D3DDEVTYPE_HAL,   //   ,  D3DDEVTYPE_HAL.
      &caps);       //    D3DCAPS9,  
                    //     .

//    ?
	int vp = 0;
	if(caps.DevCaps & D3DDEVCAPS_HWTRANSFORMANDLIGHT)
	{
		// ,   vp   
		//  .
		vp = D3DCREATE_HARDWARE_VERTEXPROCESSING;
	}
	else
	{
		// ,   vp   
		//  .
		vp = D3DCREATE_SOFTWARE_VERTEXPROCESSING;
	}



    // Set up the structure used to create the D3DDevice. Most parameters are
    // zeroed out. We set Windowed to TRUE, since we want to do D3D in a
    // window, and then set the SwapEffect to "discard", which is the most
    // efficient method of presenting the back buffer to the display.  And 
    // we request a back buffer format that matches the current desktop display 
    // format.


    D3DPRESENT_PARAMETERS d3dpp; 
    ZeroMemory( &d3dpp, sizeof(d3dpp) );
    d3dpp.Windowed = TRUE;
    d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
    d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;
	d3dpp.EnableAutoDepthStencil = TRUE;
    d3dpp.AutoDepthStencilFormat = D3DFMT_D16;



    // Create the Direct3D device. Here we are using the default adapter (most
    // systems only have one, unless they have multiple graphics hardware cards
    // installed) and requesting the HAL (which is saying we want the hardware
    // device rather than a software one). Software vertex processing is 
    // specified since we know it will work on all cards. On cards that support 
    // hardware vertex processing, though, we would see a big performance gain 
    // by specifying hardware vertex processing.
    if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
                                      vp,
                                      &d3dpp, &g_pd3dDevice ) ) )
    {
        return E_FAIL;
    }

	g_pd3dDevice->SetRenderState( D3DRS_ZENABLE, TRUE );

    // Device state would normally be set here
	g_pd3dDevice->SetRenderState( D3DRS_LIGHTING, TRUE );
	g_pd3dDevice->SetRenderState(D3DRS_SPECULARENABLE, true);
   // Turn off culling
    g_pd3dDevice->SetRenderState( D3DRS_CULLMODE, D3DCULL_NONE );

    // Turn on the zbuffer
    g_pd3dDevice->SetRenderState( D3DRS_ZENABLE, TRUE );


	
	D3DXVECTOR3 vEyePt( 0.0f, 0.0f,-20.0f );
	D3DXVECTOR3 vLookatPt( 0.0f, 0.0f, 0.0f );
	D3DXVECTOR3 vUpVec( 0.0f, 1.0f, 0.0f );
	
	camera.SetPosition(vEyePt);
	camera.SetUp(vUpVec);
	camera.SetLook(vLookatPt);
	D3DXMATRIXA16 matView = camera.GetViewMatrix();
	g_pd3dDevice->SetTransform( D3DTS_VIEW, &matView );

	float z=caps.MaxAnisotropy;
	 g_pd3dDevice->SetSamplerState(0,D3DSAMP_MAXANISOTROPY,z);
	 g_pd3dDevice->SetSamplerState(1,D3DSAMP_MAXANISOTROPY,z);
    return S_OK;
}

const int CountVertex=24;
const int CountIndex=36;
 
HRESULT InitVB()
{

float x1=0.166666666;//66666666666666666666667f;
float x2=0.8333333333;//3333333333333333333333f;
	

		
		
		
	

	CUSTOMVERTEX Vertices[CountVertex] =
    {
		//
		-2.0f,3.0f,-2.0f, 0.0f,1.0f,-6.0f,  x1,0.0f,
		2.0f,3.0f,-2.0f,0.0f,1.0f,-6.0f,    x2,0.0f,
		3.0f,-3.0f,-3.0f,0.0f,1.0f,-6.0f,  1.0f,1.0f,

       -3.0f,-3.0f,-3.0f, 	0.0f,1.0f,-6.0f,  0.0f,1.0f,
		
	   
	   //
	2.0f,3.0f,2.0f,0.0f,1.0f,6.0f,x1,0.0f,
		-2.0f,3.0f,2.0f,0.0f,1.0f,6.0f,x2,0.0f,
		-3.0f,-3.0f,3.0f,0.0f,1.0f,6.0f,	1.0f,1.0f,
		3.0f,-3.0f,3.0f,0.0f,1.0f,6.0f,0.0f,1.0f,
		//
	
		
			-2.0f,3.0f,-2.0f,	0.0f,1.0f,0.0f,		0.0f,0.0f,
			-2.0f,3.0f,2.0f,0.0f,1.0f,0.0f,1.0f,0.0f,			
			2.0f,3.0f,2.0f,0.0f,1.0f,0.0f,1.0f,1.0f,
			2.0f,3.0f,-2.0f,0.0f,1.0f,0.0f,	0.0f,1.0f,
//
			-3.0f,-3.0f,-3.0f,0.0f,-1.0f,0.0f,0.0f,0.0f,
			3.0f,-3.0f,-3.0f,0.0f,-1.0f,0.0f,1.0f,0.0f,
			3.0f,-3.0f,3.0f,0.0f,-1.0f,0.0f,	1.0f,1.0f,
			-3.0f,-3.0f,3.0f,	0.0f,-1.0f,0.0f,	0.0f,1.0f,
//////////////////////////////////
//
		2.0f,3.0f,-2.0f,	6.0f,1.0f,0.0f,	x1,0.0f,
		2.0f,3.0f,2.0f,6.0f,1.0f,0.0f,x2,0.0f,	
		3.0f,-3.0f,3.0f,6.0f,1.0f,0.0f,	1.0f,1.0f,
		3.0f,-3.0f,-3.0f,6.0f,1.0f,0.0f, 0.0f,1.0f,
//
		-2.0f,3.0f,2.0f,-6.0f,1.0f,0.0f,	x1,0.0f,
		-2.0f,3.0f,-2.0f,-6.0f,1.0f,0.0f,	x2,0.0f,
		-3.0f,-3.0f,-3.0f,-6.0f,1.0f,0.0f,	1.0f,1.0f,
		-3.0f,-3.0f,3.0f,-6.0f,1.0f,0.0f,0.0f,1.0f,
    };
	if( FAILED( g_pd3dDevice->CreateVertexBuffer( CountVertex*sizeof(CUSTOMVERTEX),
                                                  0, D3DFVF_CUSTOMVERTEX,
                                                  D3DPOOL_DEFAULT, &g_pVB, NULL ) ) )
    {
        return E_FAIL;
    }

    // Now we fill the vertex buffer. To do this, we need to Lock() the VB to
    // gain access to the Vertices. This mechanism is required becuase vertex
    // buffers may be in device memory.
    VOID* pVertices;
    if( FAILED( g_pVB->Lock( 0, sizeof(Vertices), (void**)&pVertices, 0 ) ) )
        return E_FAIL;
    memcpy( pVertices, Vertices, sizeof(Vertices) );
    g_pVB->Unlock();


	WORD Indexes[CountIndex] = 
	{
		//
		0,1,2,
		0,2,3,
		//
		4,5,6,
		4,6,7,
		//
		8,9,10,
		8,10,11,
		//
		12,13,14,
		12,14,15,
		//
		16,17,18,
		16,18,19,
		//
		20,21,22,
		20,22,23,
	};


	if( FAILED( g_pd3dDevice->CreateIndexBuffer( CountIndex * sizeof(WORD),
               0,
               D3DFMT_INDEX16,
               D3DPOOL_MANAGED,
               &g_pIB,
               0) ))
    {
        return E_FAIL;
    }

    // Now we fill the vertex buffer. To do this, we need to Lock() the VB to
    // gain access to the Vertices. This mechanism is required becuase vertex
    // buffers may be in device memory.
    VOID* pIndexes;
    if( FAILED( g_pIB->Lock( 0, sizeof(Indexes), (void**)&pIndexes, 0 ) ) )
        return E_FAIL;
    memcpy( pIndexes, Indexes, sizeof(Indexes) );
    g_pVB->Unlock();
	D3DXCreateSphere(g_pd3dDevice,1.0f,20,20,&mesh,NULL);
	room.LoadFromFile("room.x");

	
	D3DXCreateTextureFromFile(
                    g_pd3dDevice,
                    "choko.bmp",
                    &Tex);


	D3DXCreateTextureFromFile(
                    g_pd3dDevice,
                    "choko.bmp",
                    &TexSphere);

	
     //  
     g_pd3dDevice->SetTexture(0, Tex);

     //   
     //g_pd3dDevice->SetSamplerState(0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR);
     //g_pd3dDevice->SetSamplerState(0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR);
     //g_pd3dDevice->SetSamplerState(0, D3DSAMP_MIPFILTER, D3DTEXF_POINT);
	 
	






    return S_OK;
}


VOID Cleanup()
{
    if( g_pd3dDevice != NULL) 
        g_pd3dDevice->Release();

    if( g_pD3D != NULL)
        g_pD3D->Release();
	if (mesh != NULL)
	{
		mesh->Release();
		room.g_pMesh ->Release();
		room.g_pMesh =NULL;
		mesh = 0;
	}

}

VOID Resize(int w, int h)
{
	
	if (h == 0)
		h = 1;
	width = w;
	height = h;

	aspectRatio = (float)w / (float)h;
	D3DXMATRIXA16 matProj;
    D3DXMatrixPerspectiveFovLH( &matProj, D3DX_PI/4, aspectRatio, 1.0f, 100.0f );
    g_pd3dDevice->SetTransform( D3DTS_PROJECTION, &matProj );
			
	
}


D3DMATERIAL9 InitMaterial(D3DXCOLOR a, D3DXCOLOR d, D3DXCOLOR s , D3DXCOLOR e , D3DXCOLOR p )
{
	D3DMATERIAL9 mtrl;
	ZeroMemory( &mtrl, sizeof(mtrl) );
	mtrl.Ambient = a;
	mtrl.Diffuse = d;
	mtrl.Specular = s;
	mtrl.Emissive = e;
	mtrl.Power = p;
	return mtrl;
}

const D3DXCOLOR     WHITE(D3DCOLOR_XRGB(255, 255, 255));
const D3DXCOLOR     BLACK(D3DCOLOR_XRGB(  0,   0,   0));
const D3DXCOLOR       RED(D3DCOLOR_XRGB(255,   0,   0));
const D3DXCOLOR     GREEN(D3DCOLOR_XRGB(  0, 255,   0));
const D3DXCOLOR      BLUE(D3DCOLOR_XRGB(  0,   0, 255));
const D3DXCOLOR    YELLOW(D3DCOLOR_XRGB(255, 255,   0));
const D3DXCOLOR      CYAN(D3DCOLOR_XRGB(  0, 255, 255));
const D3DXCOLOR   MAGENTA(D3DCOLOR_XRGB(255,   0, 255));

const D3DMATERIAL9 BLUE_MTRL = InitMaterial(BLUE, BLUE, WHITE, BLACK, 50.0f);
const D3DMATERIAL9 WHITE_MTRL = InitMaterial(WHITE, WHITE, WHITE, BLACK, 50.0f);
const D3DMATERIAL9 GREEN_MTRL = InitMaterial(GREEN, GREEN, WHITE, BLACK, 50.0f);

D3DLIGHT9 SetPointLight(D3DXVECTOR3 pos, D3DXCOLOR color)
{
	D3DLIGHT9 light;
    ::ZeroMemory(&light, sizeof(light));
	light.Type      = D3DLIGHT_POINT;
    light.Ambient   = color * 0.2f;
    light.Diffuse   = color;
    light.Specular  = color * 0.8f;
	light.Position = pos;
	light.Range = 100.0f;
	

    return light;
}



D3DXMATRIXA16 SetTetraMatrix()
{
	D3DXMATRIXA16 matWorld;
	D3DXMATRIXA16 matTemp;
	D3DXMatrixIdentity( &matWorld );
    D3DXMatrixTranslation( &matTemp, -9, 0, 0 );
	D3DXMatrixMultiply(&matWorld,  &matTemp, &matWorld);
	D3DXMatrixRotationY(&matTemp, angle);
	D3DXMatrixMultiply(&matWorld, &matTemp, &matWorld);
	D3DXMatrixTranslation(&matTemp, 2, 0, 0);
	D3DXMatrixMultiply(&matWorld, &matTemp, &matWorld);
	D3DXMatrixRotationZ(&matTemp, angle);
	D3DXMatrixMultiply(&matWorld, &matTemp, &matWorld);
	return matWorld;
}

D3DXMATRIXA16 SetTeapotMatrix()
{
	D3DXMATRIXA16 matWorld;
	D3DXMATRIXA16 matTemp;
	D3DXMatrixIdentity( &matWorld );
	D3DXMatrixTranslation( &matTemp, 0, 0, 0 );
	D3DXMatrixMultiply(&matWorld,  &matTemp, &matWorld);
		
	//D3DXMatrixRotationX(&matTemp,angle + D3DX_PI);
	//D3DXMatrixMultiply(&matWorld, &matTemp, &matWorld);
	
	//D3DXMatrixTranslation(&matTemp, 2, 0, 0);
	//D3DXMatrixMultiply(&matWorld, &matTemp, &matWorld);
	//D3DXMatrixRotationY(&matTemp, angle + D3DX_PI/3);
	//D3DXMatrixMultiply(&matWorld, &matTemp, &matWorld);
	
	return matWorld;
}

D3DXMATRIXA16 UpdateViewMatrix(float timeDelta)
{
	if(::GetAsyncKeyState('W') & 0x8000f)
        camera.walk(0.1f * timeDelta);

    if(::GetAsyncKeyState('S') & 0x8000f)
        camera.walk(-0.1f * timeDelta);

    if(::GetAsyncKeyState('A') & 0x8000f)
        camera.strafe(-0.1f * timeDelta);

    if(::GetAsyncKeyState('D') & 0x8000f)
        camera.strafe(0.1f * timeDelta);

    if(::GetAsyncKeyState('R') & 0x8000f)
        camera.fly(0.1f * timeDelta);

    if(::GetAsyncKeyState('F') & 0x8000f)
        camera.fly(-0.1f * timeDelta);

    if(::GetAsyncKeyState(VK_UP) & 0x8000f)
        camera.pitch(0.01f * timeDelta);

    if(::GetAsyncKeyState(VK_DOWN) & 0x8000f)
        camera.pitch(-0.01f * timeDelta);

    if(::GetAsyncKeyState(VK_LEFT) & 0x8000f)
        camera.yaw(-0.01f * timeDelta);

    if(::GetAsyncKeyState(VK_RIGHT) & 0x8000f)
        camera.yaw(0.01f * timeDelta);

    if(::GetAsyncKeyState('N') & 0x8000f)
        camera.roll(0.1f * timeDelta);

    if(::GetAsyncKeyState('M') & 0x8000f)
        camera.roll(-0.1f * timeDelta);

    //     
    //   
    return camera.GetViewMatrix();
}

void SetupLights()
{
	D3DLIGHT9 light0,light1;
	ZeroMemory(&light0,sizeof(light0));
	ZeroMemory(&light1,sizeof(light1));
	light0.Type=D3DLIGHT_SPOT;
	D3DXCOLOR color0=D3DXCOLOR(l0,l0,l0,l0);
	light0.Diffuse=color0;
	light0.Direction =D3DXVECTOR3(0.0f,-1.0f,0.0f);
	light0.Position =D3DXVECTOR3(0.0f,7.0f,0.0f);

	light0.Specular=color0;
	light0.Attenuation0=1.0f;
		light0.Attenuation1=0.0f;
		light0.Attenuation2=0.0f;
	light0.Range =10.0f;
	light0.Theta =1.9f;
	light0.Falloff =1.0f;
	light0.Phi =2.0f;
	g_pd3dDevice->SetRenderState(D3DRS_LIGHTING,TRUE);
	g_pd3dDevice->SetRenderState(D3DRS_SPECULARENABLE,TRUE);
	g_pd3dDevice->SetLight(0,&light0);
	g_pd3dDevice->LightEnable(0,true);

	light1.Type=D3DLIGHT_SPOT;
	D3DXCOLOR color2=D3DXCOLOR(l1,l1,l1,l1);
	light1.Diffuse=color2;
	light1.Direction =D3DXVECTOR3(-1.0f,0.0f,0.0f);
	light1.Position =D3DXVECTOR3(7.0f,5.0f,0.0f);
	
	light1.Specular=color2;
	light1.Attenuation0=1.0f;
		light1.Attenuation1=0.0f;
		light1.Attenuation2=0.0f;
	light1.Range =10.0f;
	light1.Theta =1.9f;
	light1.Falloff =1.0f;
	light1.Phi =2.0f;
	g_pd3dDevice->SetLight(1,&light1);
	g_pd3dDevice->LightEnable(1,true);
	 

}

VOID Render(float timeDelta)
{
    if( NULL == g_pd3dDevice )
        return;

	D3DXMATRIXA16 V = UpdateViewMatrix(timeDelta);
    g_pd3dDevice->SetTransform(D3DTS_VIEW, &V);

    g_pd3dDevice->Clear( 0, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, D3DCOLOR_XRGB(0,0,0), 1.0f, 0 );
    
    // Begin the scene
    if( SUCCEEDED( g_pd3dDevice->BeginScene() ) )
    {
        D3DXMATRIXA16 matTetrahedron;
		D3DXMATRIXA16 matTeapot;
		
		g_pd3dDevice->SetRenderState( D3DRS_AMBIENT, 0x00202020 );
		SetupLights();
  
		D3DXMATRIXA16 mat;
		D3DXMatrixTranslation(&mat,0.0f,-5.0f,0.0f);
		g_pd3dDevice->SetTransform(D3DTS_WORLD,&mat);
        // a loop
		room.Draw();
		



		matTetrahedron = SetTetraMatrix();
		g_pd3dDevice->SetTransform( D3DTS_WORLD, &matTetrahedron );
		g_pd3dDevice->SetMaterial(&WHITE_MTRL);
		g_pd3dDevice->SetTexture(0, Tex);
	    //g_pd3dDevice->SetTexture(0, 0);
		g_pd3dDevice->SetStreamSource( 0, g_pVB, 0, sizeof(CUSTOMVERTEX) );
		g_pd3dDevice->SetFVF( D3DFVF_CUSTOMVERTEX );
		g_pd3dDevice->SetIndices(g_pIB);
		g_pd3dDevice->DrawIndexedPrimitive(D3DPT_TRIANGLELIST , 0, 0, CountVertex, 0, CountIndex/3 );


		g_pd3dDevice->SetTexture(0,TexSphere);
		matTeapot = SetTeapotMatrix();
		g_pd3dDevice->SetTransform( D3DTS_WORLD, &matTeapot);
		g_pd3dDevice->SetMaterial(&WHITE_MTRL);
		g_pd3dDevice->SetTextureStageState(0, D3DTSS_TEXCOORDINDEX, 
                                   D3DTSS_TCI_CAMERASPACENORMAL );
		

			// in the 0 to 1 range.
			static float a=0.5f;
	a+=0.01f;
	if (a>D3DX_PI*2) a=0;
	D3DXMATRIXA16 mTextureTransform;
	D3DXMATRIXA16 mProj;
	D3DXMATRIXA16 mTrans;
	D3DXMATRIXA16 mScale;
	D3DXMATRIXA16 mRot;
	g_pd3dDevice->GetTransform( D3DTS_PROJECTION, &mProj );
	D3DXMatrixTranslation( &mTrans, 0.5f, 0.5f, 0.0f );

	D3DXMatrixScaling( &mScale,-0.5f, -0.5f, 1.0f );

	D3DXVECTOR3 Eye=camera.GetPosition();
	D3DXVECTOR3 look=camera.GetLook();
	D3DXVECTOR3 up=D3DXVECTOR3(0.0f,1.0f,0.0f);
	//D3DXMatrixLookAtLH(&mRot,&Eye,&look,&up);
	D3DXMatrixRotationY(&mRot,a);
	//g_pd3dDevice->GetTransform(D3DTS_WORLD,&mScale);
	mTextureTransform = mProj * mScale*mRot * mTrans;

	g_pd3dDevice->SetTransform( D3DTS_TEXTURE0, &mTextureTransform );
	g_pd3dDevice->SetTextureStageState( 0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_COUNT4 | D3DTTFF_PROJECTED );
	g_pd3dDevice->SetTextureStageState( 0, D3DTSS_TEXCOORDINDEX,D3DTSS_TCI_SPHEREMAP);


	mesh->DrawSubset(0);
	g_pd3dDevice->SetTextureStageState( 0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_DISABLE);
		g_pd3dDevice->SetTextureStageState( 0, D3DTSS_TEXCOORDINDEX, D3DTSS_TCI_PASSTHRU );
			// End the scene
		g_pd3dDevice->EndScene();
    }

    // Present the backbuffer contents to the display
    g_pd3dDevice->Present( NULL, NULL, NULL, NULL );
	
}



int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_LAB6D3D, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);
	
	

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_LAB6D3D);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
		
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_CLASSDC; //CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_LAB6D3D);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCTSTR)IDC_LAB6D3D;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   if( SUCCEEDED( InitD3D( hWnd ) ) )
    {
		if( SUCCEEDED( InitVB() ) )
        {

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);
   SetTimer(hWnd, 101, 20, NULL);
   return TRUE;
		}
		else return FALSE;
	}
   else
	   return FALSE;

   
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	DWORD tm;
	char *FileName=NULL;
	switch (message) 
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		case IDM_PYRAMIDTEXTURE:
		
			FileName=OpenNewFile(hWnd,"dfg");
			if (FileName)
			{	Tex->Release();
			
			D3DXCreateTextureFromFile(
                    g_pd3dDevice,
                    FileName,
                    &Tex);
			}
			break;
		case IDM_SPHERETEXTURE:
			FileName=OpenNewFile(hWnd,"dfg");
			if (FileName)
			{	TexSphere->Release();
			
			D3DXCreateTextureFromFile(
                    g_pd3dDevice,
                    FileName,
                    &TexSphere);
			}
			break;
		case IDM_NOPYRAMIDTEXTURE:
			Tex->Release();
			Tex=NULL;
			break;
		case IDM_NOSPHERETEXTURE:
			TexSphere->Release();
			TexSphere=NULL;
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_TIMER:
		tm = GetTickCount();
		tm -= stm;
		stm = tm;
		timeDelta = tm*0.000001;
		MyTimerProc();
		InvalidateRect(hWnd, NULL, FALSE);
		break;
	case WM_SIZE:
		Resize(LOWORD(lParam), HIWORD(lParam));
		break;
	case WM_PAINT:
		Render(timeDelta);
        ValidateRect( hWnd, NULL );
		break;
	case WM_CHAR:
		char c;
		c=wParam;
		switch (c)
		{
		case 'v':
		case 'V':
			l0-=0.1;
			break;
		case 'b':
		case 'B':
			l0+=0.1;
			break;
		case 'x':
		case 'X':
			l1-=0.1;
			break;
		case 'c':
		case 'C':
			l1+=0.1;
			break;
		}
		break;
	case WM_DESTROY:
		KillTimer(hWnd, 101); 
		Cleanup();
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}


HRESULT CMesh::LoadFromFile(char *FileName)
{
/////////////////////////
	//  :
	 LPD3DXBUFFER pD3DXMtrlBuffer;
	   // If model is not in current folder, try parent folder
        if( FAILED( D3DXLoadMeshFromX( FileName, D3DXMESH_SYSTEMMEM, 
                                    g_pd3dDevice, NULL, 
                                    &pD3DXMtrlBuffer, NULL, &g_dwNumMaterials, 
                                    &g_pMesh ) ) )
        {
            MessageBox(NULL, "Could not find tiger.x", "Meshes.exe", MB_OK);
            return E_FAIL;
        }
    

    // We need to extract the material properties and texture names from the 
    // pD3DXMtrlBuffer
    D3DXMATERIAL* d3dxMaterials = (D3DXMATERIAL*)pD3DXMtrlBuffer->GetBufferPointer();
    g_pMeshMaterials = new D3DMATERIAL9[g_dwNumMaterials];
    if( g_pMeshMaterials == NULL )
        return E_OUTOFMEMORY;
    g_pMeshTextures  = new LPDIRECT3DTEXTURE9[g_dwNumMaterials];
    if( g_pMeshTextures == NULL )
        return E_OUTOFMEMORY;

    for( DWORD i=0; i<g_dwNumMaterials; i++ )
    {
        // Copy the material
        g_pMeshMaterials[i] = d3dxMaterials[i].MatD3D;

        // Set the ambient color for the material (D3DX does not do this)
        g_pMeshMaterials[i].Ambient = g_pMeshMaterials[i].Diffuse;

        g_pMeshTextures[i] = NULL;
        if( d3dxMaterials[i].pTextureFilename != NULL && 
            lstrlen(d3dxMaterials[i].pTextureFilename) > 0 )
        {
            // Create the texture
            if( FAILED( D3DXCreateTextureFromFile( g_pd3dDevice, 
                                                d3dxMaterials[i].pTextureFilename, 
                                                &g_pMeshTextures[i] ) ) )
            {
                // If texture is not in current folder, try parent folder
                const TCHAR* strPrefix = TEXT("..\\");
                TCHAR strTexture[MAX_PATH];
                StringCchCopy( strTexture, MAX_PATH, strPrefix );
                StringCchCat( strTexture, MAX_PATH, d3dxMaterials[i].pTextureFilename );
                // If texture is not in current folder, try parent folder
                if( FAILED( D3DXCreateTextureFromFile( g_pd3dDevice, 
                                                    strTexture, 
                                                    &g_pMeshTextures[i] ) ) )
                {
                    MessageBox(NULL, "Could not find texture map", "Meshes.exe", MB_OK);
                }
            }
        }
    }

    // Done with the material buffer
    pD3DXMtrlBuffer->Release();

}

void CMesh::Draw()
{
	// Meshes are divided into subsets, one for each material. Render them in
        for( DWORD i=0; i<g_dwNumMaterials; i++ )
        {
            // Set the material and texture for this subset
            g_pd3dDevice->SetMaterial( &g_pMeshMaterials[i] );
            g_pd3dDevice->SetTexture( 0, g_pMeshTextures[i] );
        
            // Draw the mesh subset
            g_pMesh->DrawSubset( i );
        }
}